/* dyncrt.p - dynamic create */

def var bh as handle no-undo.
def var fh as handle no-undo.
def var i  as int    no-undo.
def var c  as char   no-undo.
def var d  as dec    no-undo.

create buffer bh for table "grade".

/* transaction block required for dynamic transactions */
do transaction:
  bh:buffer-create().
  do i = 1 to bh:num-fields with down:
    fh = bh:buffer-field(i).
    display fh:name format "x(15)" label "Field".
    case fh:data-type:
      when "decimal" then do:
        d = fh:buffer-value.
        update d.
        fh:buffer-value = d.
      end. /* "decimal" */
      when "character" then do:
        c = fh:buffer-value.
        update c.
        fh:buffer-value = c.
      end. /* "character" */
    end case.
  end. /* do i = 1 to bh:num-fields */
  /* order does matter, delete fh first since it is based on bh */
  /* no-error will prevent an error message, thereby undoing the */
  /* transaction if they are in the wrong order. */
  delete object fh no-error.
  delete object bh no-error.
end. /* do transaction */
