/* trnevt2.p - query event driven example */

define query q1 for student.

define button bfirst label "First".
define button bnext label "Next".
define button bprev label "Prev".
define button blast label "Last".
define button bupd label "Update".
define button bfull label "Full".
define button bexit label "Exit".

define frame stud-frame
studentid sfirstname slastname address1 city stcode postalcode
with 1 column.

define frame but-frame
bfirst bnext bprev blast bupd bfull bexit
with row 10.

on choose of bfirst
do:
  get first q1 no-lock.
  if available student then run dispstud.
end.

on choose of bnext
do:
  get next q1 no-lock.
  if available student then run dispstud.
end.

on choose of bprev
do:
  get prev q1 no-lock.
  if available student then run dispstud.
end.

on choose of blast
do:
  get last q1 no-lock.
  if available student then run dispstud.
end.

on choose of bfull
do:
  if available student then display student except picture
  with 2 columns title "Full Record".
  run dispstud.
end.

on choose of bupd
do:
  def buffer studbuf for student.
  if available student then 
  do with 1 column view-as dialog-box title "Student Update":
    find  studbuf exclusive-lock
      where studbuf.studentid = student.studentid no-error.
    display studbuf.studentid studbuf.gpa studbuf.balanceamt.
    update studbuf except studentid balanceamt gpa addressagg picture.
    run dispstud.
  end.
end.

on choose of bexit
do:
  message "Program exiting before wait-for ended" view-as alert-box.
end.

default-window:title = "Event Driven Transaction 2".

open query q1 for each student no-lock.
get first q1 no-lock.

run dispstud.

enable all
with frame but-frame.

wait-for choose of bexit.

procedure dispstud:
  display student.studentid 
          sfirstname slastname address1 city stcode postalcode with frame stud-frame.
end.
